var loopback = require('loopback');
var boot = require('loopback-boot');
var path = require('path');

var app = module.exports = loopback();

var scribe = require('scribe-js')(); //loads Scribe
app.use(scribe.express.logger()); //Log each request
app.use('/logs', scribe.webPanel());
app.use(loopback.static(path.resolve(__dirname, '../common')));
app.set('views', './common/views');
app.set('view engine', 'html');
app.engine('html', require('ejs').renderFile);

//app.use(bodyParser.json());
app.start = function() {
  // start the web server
  return app.listen(function() {
    app.emit('started');
    var baseUrl = app.get('url').replace(/\/$/, '');
    console.log('Web server listening at: %s', baseUrl);
    if (app.get('loopback-component-explorer')) {
      var explorerPath = app.get('loopback-component-explorer').mountPath;
      console.log('Browse your REST API at %s%s', baseUrl, explorerPath);
    }
  });
};

// Bootstrap the application, configure models, datasources and middleware.
// Sub-apps like REST API are mounted via boot scripts.
boot(app, __dirname, function(err) {
  if (err) throw err;

  // start the server if `$ node server.js`
  if (require.main === module)
    app.start();
});
